﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Windows.Threading;

namespace WpfApplication223
{
    public class PersonViewModel : INotifyPropertyChanged
    {
        private static int posRange = 0;
        private DispatcherTimer _timer;

        public DateTime UpdatedOn { get { return DateTime.Now; } }
        public ObservableCollection<Person> people { get; set; }
        public delegate void RepositionGrid();

        public RepositionGrid resetscroll;
         


        public PersonViewModel()
        {
            addData(0, 100, "I");

            _timer = new DispatcherTimer { Interval = new TimeSpan(0, 0, 13) };
            _timer.Tick += (s, e) => addData(0, 100, "F");
            _timer.Start();
        }


        public void addData(int startCount, int endCount, string mode)
        {

             
            //if (mode == "I")
            //{
                people = new ObservableCollection<Person>();
            //}

            for (int i = startCount + posRange; i < endCount + posRange; i++)
            {
                Person p = new Person()
                {
                    Name = "name " + i.ToString(),
                    ID = i
                };
                if (mode == "F")
                {
                    people.Insert(people.Count, p);
                }
                else people.Add(p);
            }

            people.OrderBy(x => x.ID);

            posRange += 0;

            if (resetscroll != null)
            {
                resetscroll.Invoke();
            }

            RaisePropertyChangedEvent("people");
            RaisePropertyChangedEvent("UpdatedOn");
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        internal void RaisePropertyChangedEvent(string propertyName)
        {
            if (PropertyChanged == null)
            {
                return;
            }

            PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
        #endregion
    }
}
